Index: /trunk/BNC/bncsettings.cpp
===================================================================
--- /trunk/BNC/bncsettings.cpp	(revision 3163)
+++ /trunk/BNC/bncsettings.cpp	(revision 3164)
@@ -110,6 +110,6 @@
     setValue("cmbOutPath",       "");
     setValue("cmbSP3Path",       "");
-    setValue("rtnetUploadMountpoints",   "");
-    setValue("rtnetMountpointIn", "");
+    setValue("uploadMountpointsOut",   "");
+    setValue("uploadMountpointIn", "");
     sync();
   }
Index: /trunk/BNC/bncwindow.cpp
===================================================================
--- /trunk/BNC/bncwindow.cpp	(revision 3163)
+++ /trunk/BNC/bncwindow.cpp	(revision 3164)
@@ -471,28 +471,28 @@
           this, SLOT(slotBncTextChanged()));
 
-  // RTNet Results
+  // Upload Results
   // -------------
-  _rtnetTable = new QTableWidget(0,7);
-  _rtnetTable->setHorizontalHeaderLabels(QString("Host, Port, Mount, Password, System, CoM, File").split(","));
-  _rtnetTable->setSelectionMode(QAbstractItemView::ExtendedSelection);
-  _rtnetTable->setSelectionBehavior(QAbstractItemView::SelectRows);
-  _rtnetTable->setMaximumWidth(70*ww);
-  _rtnetTable->horizontalHeader()->resizeSection(0,13*ww); 
-  _rtnetTable->horizontalHeader()->resizeSection(1,5*ww); 
-  _rtnetTable->horizontalHeader()->resizeSection(2,6*ww); 
-  _rtnetTable->horizontalHeader()->resizeSection(3,8*ww); 
-  _rtnetTable->horizontalHeader()->resizeSection(4,11*ww); 
-  _rtnetTable->horizontalHeader()->resizeSection(5,4*ww); 
-  _rtnetTable->horizontalHeader()->resizeSection(6,20*ww); 
-  _rtnetTable->horizontalHeader()->setResizeMode(QHeaderView::Interactive);
-  ///  _rtnetTable->horizontalHeader()->setStretchLastSection(true);
-  _rtnetTable->horizontalHeader()->setDefaultAlignment(Qt::AlignLeft);
-
-  QPushButton* addRtnetRowButton = new QPushButton("Add Row");
-  QPushButton* delRtnetRowButton = new QPushButton("Delete");
-  QPushButton* setRtnetTrafoButton = new QPushButton("Set");
-  _rtnetMountpointIn = new QLineEdit(settings.value("rtnetMountpointIn").toString());
-
-  connect(_rtnetTable, SIGNAL(itemSelectionChanged()), 
+  _uploadTable = new QTableWidget(0,7);
+  _uploadTable->setHorizontalHeaderLabels(QString("Host, Port, Mount, Password, System, CoM, File").split(","));
+  _uploadTable->setSelectionMode(QAbstractItemView::ExtendedSelection);
+  _uploadTable->setSelectionBehavior(QAbstractItemView::SelectRows);
+  _uploadTable->setMaximumWidth(70*ww);
+  _uploadTable->horizontalHeader()->resizeSection(0,13*ww); 
+  _uploadTable->horizontalHeader()->resizeSection(1,5*ww); 
+  _uploadTable->horizontalHeader()->resizeSection(2,6*ww); 
+  _uploadTable->horizontalHeader()->resizeSection(3,8*ww); 
+  _uploadTable->horizontalHeader()->resizeSection(4,11*ww); 
+  _uploadTable->horizontalHeader()->resizeSection(5,4*ww); 
+  _uploadTable->horizontalHeader()->resizeSection(6,20*ww); 
+  _uploadTable->horizontalHeader()->setResizeMode(QHeaderView::Interactive);
+  ///  _uploadTable->horizontalHeader()->setStretchLastSection(true);
+  _uploadTable->horizontalHeader()->setDefaultAlignment(Qt::AlignLeft);
+
+  QPushButton* addUploadRowButton = new QPushButton("Add Row");
+  QPushButton* delUploadRowButton = new QPushButton("Delete");
+  QPushButton* setUploadTrafoButton = new QPushButton("Set");
+  _uploadMountpointIn = new QLineEdit(settings.value("uploadMountpointIn").toString());
+
+  connect(_uploadTable, SIGNAL(itemSelectionChanged()), 
           SLOT(slotBncTextChanged()));
 
@@ -607,5 +607,5 @@
   QWidget* ppp2group = new QWidget();
   QWidget* cmbgroup = new QWidget();
-  QWidget* rtnetgroup = new QWidget();
+  QWidget* uploadgroup = new QWidget();
   _aogroup->addTab(pgroup,tr("Proxy"));
   _aogroup->addTab(ggroup,tr("General"));
@@ -622,5 +622,5 @@
   _aogroup->addTab(cmbgroup,tr("Combination"));
 #endif
-  _aogroup->addTab(rtnetgroup,tr("Upload"));
+  _aogroup->addTab(uploadgroup,tr("Upload"));
 
   // Log Tab
@@ -954,33 +954,33 @@
   cmbgroup->setLayout(cmbLayout);
 
-  // RTNet Layout
+  // Upload Layout
   // ------------
-  QGridLayout* rtnetLayout = new QGridLayout;
-
-  populateRtnetTable();
-  rtnetLayout->addWidget(_rtnetTable,0,0,6,7);
-  rtnetLayout->setColumnStretch(0,1);
-  rtnetLayout->setColumnStretch(1,1);
-  rtnetLayout->setColumnStretch(2,1);
-  rtnetLayout->setColumnStretch(3,1);
-  rtnetLayout->setColumnStretch(4,1);
-  rtnetLayout->setColumnStretch(5,1);
-  rtnetLayout->setColumnStretch(7,1);
-
-  rtnetLayout->addWidget(addRtnetRowButton,0,8);
-  connect(addRtnetRowButton, SIGNAL(clicked()), this, SLOT(slotAddRtnetRow()));
-  rtnetLayout->addWidget(delRtnetRowButton,1,8);
-  connect(delRtnetRowButton, SIGNAL(clicked()), this, SLOT(slotDelRtnetRow()));
-
-  rtnetLayout->addWidget(new QLabel("Mountpoint"),3,8);
-  rtnetLayout->addWidget(_rtnetMountpointIn,3,9,1,2);
-
-  rtnetLayout->addWidget(new QLabel("Custom Trafo"),4,8);
-  rtnetLayout->addWidget(setRtnetTrafoButton,4,9);
-  connect(setRtnetTrafoButton, SIGNAL(clicked()), this, SLOT(slotSetRtnetTrafo()));
-
-  rtnetLayout->addWidget(new QLabel("Upload RTNet results to NTRIP caster"),5,8,1,5);
-
-  rtnetgroup->setLayout(rtnetLayout);
+  QGridLayout* uploadLayout = new QGridLayout;
+
+  populateUploadTable();
+  uploadLayout->addWidget(_uploadTable,0,0,6,7);
+  uploadLayout->setColumnStretch(0,1);
+  uploadLayout->setColumnStretch(1,1);
+  uploadLayout->setColumnStretch(2,1);
+  uploadLayout->setColumnStretch(3,1);
+  uploadLayout->setColumnStretch(4,1);
+  uploadLayout->setColumnStretch(5,1);
+  uploadLayout->setColumnStretch(7,1);
+
+  uploadLayout->addWidget(addUploadRowButton,0,8);
+  connect(addUploadRowButton, SIGNAL(clicked()), this, SLOT(slotAddUploadRow()));
+  uploadLayout->addWidget(delUploadRowButton,1,8);
+  connect(delUploadRowButton, SIGNAL(clicked()), this, SLOT(slotDelUploadRow()));
+
+  uploadLayout->addWidget(new QLabel("Mountpoint"),3,8);
+  uploadLayout->addWidget(_uploadMountpointIn,3,9,1,2);
+
+  uploadLayout->addWidget(new QLabel("Custom Trafo"),4,8);
+  uploadLayout->addWidget(setUploadTrafoButton,4,9);
+  connect(setUploadTrafoButton, SIGNAL(clicked()), this, SLOT(slotSetUploadTrafo()));
+
+  uploadLayout->addWidget(new QLabel("Upload RTNet results to NTRIP caster"),5,8,1,5);
+
+  uploadgroup->setLayout(uploadLayout);
 
   // Main Layout
@@ -1287,30 +1287,30 @@
   }
 
-  QStringList rtnetUploadMountpoints;
-  for (int iRow = 0; iRow < _rtnetTable->rowCount(); iRow++) {
+  QStringList uploadMountpointsOut;
+  for (int iRow = 0; iRow < _uploadTable->rowCount(); iRow++) {
     QString hlp;
-    for (int iCol = 0; iCol < _rtnetTable->columnCount(); iCol++) {
-      if (_rtnetTable->cellWidget(iRow, iCol) && 
+    for (int iCol = 0; iCol < _uploadTable->columnCount(); iCol++) {
+      if (_uploadTable->cellWidget(iRow, iCol) && 
           (iCol == 3 || iCol == 4 || iCol == 5)) {
         if      (iCol == 3) {
-          QLineEdit* passwd = (QLineEdit*)(_rtnetTable->cellWidget(iRow, iCol));
+          QLineEdit* passwd = (QLineEdit*)(_uploadTable->cellWidget(iRow, iCol));
           hlp += passwd->text() + ",";
         }
         else if (iCol == 4) {
-          QComboBox* system = (QComboBox*)(_rtnetTable->cellWidget(iRow, iCol));
+          QComboBox* system = (QComboBox*)(_uploadTable->cellWidget(iRow, iCol));
           hlp += system->currentText() + ",";
         }
         else if (iCol == 5) {
-          QCheckBox* com    = (QCheckBox*)(_rtnetTable->cellWidget(iRow, iCol));
+          QCheckBox* com    = (QCheckBox*)(_uploadTable->cellWidget(iRow, iCol));
           QString state; state.setNum(com->checkState());
           hlp +=  state + ",";
         }
       }
-      else if (_rtnetTable->item(iRow, iCol)) {
-        hlp += _rtnetTable->item(iRow, iCol)->text() + ",";
+      else if (_uploadTable->item(iRow, iCol)) {
+        hlp += _uploadTable->item(iRow, iCol)->text() + ",";
       }
     }
     if (!hlp.isEmpty()) {
-      rtnetUploadMountpoints << hlp;
+      uploadMountpointsOut << hlp;
     }
   }
@@ -1403,11 +1403,11 @@
   settings.setValue("cmbSP3Path",    _cmbSP3PathLineEdit->text());
 
-  if (!rtnetUploadMountpoints.isEmpty()) {
-    settings.setValue("rtnetUploadMountpoints", rtnetUploadMountpoints);
+  if (!uploadMountpointsOut.isEmpty()) {
+    settings.setValue("uploadMountpointsOut", uploadMountpointsOut);
   }
   else {
-    settings.setValue("rtnetUploadMountpoints", "");
-  }
-  settings.setValue("rtnetMountpointIn", _rtnetMountpointIn->text());
+    settings.setValue("uploadMountpointsOut", "");
+  }
+  settings.setValue("uploadMountpointIn", _uploadMountpointIn->text());
 
   if (_caster) {
@@ -2211,13 +2211,13 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void bncWindow::slotAddRtnetRow() {
-  int iRow = _rtnetTable->rowCount();
-  _rtnetTable->insertRow(iRow);
-  for (int iCol = 0; iCol < _rtnetTable->columnCount(); iCol++) {
+void bncWindow::slotAddUploadRow() {
+  int iRow = _uploadTable->rowCount();
+  _uploadTable->insertRow(iRow);
+  for (int iCol = 0; iCol < _uploadTable->columnCount(); iCol++) {
     if      (iCol == 3) {
       QLineEdit* passwd = new QLineEdit();
       passwd->setFrame(false);
       passwd->setEchoMode(QLineEdit::PasswordEchoOnEdit);
-      _rtnetTable->setCellWidget(iRow, iCol, passwd);
+      _uploadTable->setCellWidget(iRow, iCol, passwd);
     }
     else if (iCol == 4) {
@@ -2226,12 +2226,12 @@
       system->addItems(QString("IGS05,ETRF2000,NAD83,GDA94,SIRGAS95,SIRGAS2000,Custom").split(","));
       system->setFrame(false);
-      _rtnetTable->setCellWidget(iRow, iCol, system);
+      _uploadTable->setCellWidget(iRow, iCol, system);
     }
     else if (iCol == 5) {
       QCheckBox* com = new QCheckBox();
-      _rtnetTable->setCellWidget(iRow, iCol, com);
+      _uploadTable->setCellWidget(iRow, iCol, com);
     }
     else {
-      _rtnetTable->setItem(iRow, iCol, new QTableWidgetItem(""));
+      _uploadTable->setItem(iRow, iCol, new QTableWidgetItem(""));
     }
   }
@@ -2240,9 +2240,9 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void bncWindow::slotDelRtnetRow() {
-  int nRows = _rtnetTable->rowCount();
+void bncWindow::slotDelUploadRow() {
+  int nRows = _uploadTable->rowCount();
   bool flg[nRows];
   for (int iRow = 0; iRow < nRows; iRow++) {
-    if (_rtnetTable->isItemSelected(_rtnetTable->item(iRow,1))) {
+    if (_uploadTable->isItemSelected(_uploadTable->item(iRow,1))) {
       flg[iRow] = true;
     }
@@ -2253,5 +2253,5 @@
   for (int iRow = nRows-1; iRow >= 0; iRow--) {
     if (flg[iRow]) {
-      _rtnetTable->removeRow(iRow);
+      _uploadTable->removeRow(iRow);
     }
   }
@@ -2260,7 +2260,7 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void bncWindow::populateRtnetTable() {
-  for (int iRow = _rtnetTable->rowCount()-1; iRow >=0; iRow--) {
-    _rtnetTable->removeRow(iRow);
+void bncWindow::populateUploadTable() {
+  for (int iRow = _uploadTable->rowCount()-1; iRow >=0; iRow--) {
+    _uploadTable->removeRow(iRow);
   }
 
@@ -2268,10 +2268,10 @@
 
   int iRow = -1;
-  QListIterator<QString> it(settings.value("rtnetUploadMountpoints").toStringList());
+  QListIterator<QString> it(settings.value("uploadMountpointsOut").toStringList());
   while (it.hasNext()) {
     QStringList hlp = it.next().split(",");
     if (hlp.size() > 6) {
       ++iRow;
-      _rtnetTable->insertRow(iRow);
+      _uploadTable->insertRow(iRow);
     }
     for (int iCol = 0; iCol < hlp.size(); iCol++) {
@@ -2281,5 +2281,5 @@
         passwd->setEchoMode(QLineEdit::PasswordEchoOnEdit);
         passwd->setText(hlp[iCol]);
-        _rtnetTable->setCellWidget(iRow, iCol, passwd);
+        _uploadTable->setCellWidget(iRow, iCol, passwd);
       }
       else if (iCol == 4) {
@@ -2289,5 +2289,5 @@
         system->setFrame(false);
         system->setCurrentIndex(system->findText(hlp[iCol]));
-        _rtnetTable->setCellWidget(iRow, iCol, system);
+        _uploadTable->setCellWidget(iRow, iCol, system);
       }
       else if (iCol == 5) {
@@ -2296,8 +2296,8 @@
           com->setCheckState(Qt::Checked);
         }
-        _rtnetTable->setCellWidget(iRow, iCol, com);
+        _uploadTable->setCellWidget(iRow, iCol, com);
       }
       else {
-        _rtnetTable->setItem(iRow, iCol, new QTableWidgetItem(hlp[iCol]));
+        _uploadTable->setItem(iRow, iCol, new QTableWidgetItem(hlp[iCol]));
       }
     }
@@ -2307,4 +2307,4 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void bncWindow::slotSetRtnetTrafo() {
-}
+void bncWindow::slotSetUploadTrafo() {
+}
Index: /trunk/BNC/bncwindow.h
===================================================================
--- /trunk/BNC/bncwindow.h	(revision 3163)
+++ /trunk/BNC/bncwindow.h	(revision 3164)
@@ -81,7 +81,7 @@
     void slotAddCmbRow();
     void slotDelCmbRow();
-    void slotAddRtnetRow();
-    void slotDelRtnetRow();
-    void slotSetRtnetTrafo();
+    void slotAddUploadRow();
+    void slotDelUploadRow();
+    void slotSetUploadTrafo();
 
   protected:
@@ -91,5 +91,5 @@
     void populateMountPointsTable();
     void populateCmbTable();
-    void populateRtnetTable();
+    void populateUploadTable();
 
     QMenu*     _menuHlp;
@@ -203,6 +203,6 @@
     QLineEdit*    _cmbSP3PathLineEdit;
 
-    QTableWidget* _rtnetTable;
-    QLineEdit*    _rtnetMountpointIn;
+    QTableWidget* _uploadTable;
+    QLineEdit*    _uploadMountpointIn;
 
     bncCaster* _caster;