Index: trunk/BNC/upload/bncrtnetdecoder.cpp
===================================================================
--- trunk/BNC/upload/bncrtnetdecoder.cpp	(revision 3172)
+++ trunk/BNC/upload/bncrtnetdecoder.cpp	(revision 3174)
@@ -125,5 +125,5 @@
           in >> prn;
           prns << prn;
-          if ( _ephList.contains(prn) ) {
+          if ( _eph.contains(prn) ) {
             in >> xx(1) >> xx(2) >> xx(3) >> xx(4) >> xx(5) 
                >> xx(6) >> xx(7) >> xx(8) >> xx(9) >> xx(10)
@@ -142,5 +142,5 @@
             xx(14) *= 1e3;         // z-crd at time + dT
 
-            pair     = _ephList[prn];
+            pair     = _eph[prn];
             pair->xx = xx;
           }
@@ -148,6 +148,6 @@
         else {
           prn = prns[ii];
-          if ( _ephList.contains(prn) ) {
-            pair = _ephList[prn];
+          if ( _eph.contains(prn) ) {
+            pair = _eph[prn];
             xx   = pair->xx;
           }
@@ -158,8 +158,8 @@
         t_eph* ep = 0;
         if (pair) {
-          ep = pair->eph;
-          if (pair->oldEph && ep && 
+          ep = pair->last;
+          if (pair->prev && ep && 
               ep->receptDateTime().secsTo(QDateTime::currentDateTime()) < 60) {
-            ep = pair->oldEph;
+            ep = pair->prev;
           }
         }
@@ -229,14 +229,4 @@
         int len = MakeClockOrbit(&co, COTYPE_AUTO, 0, obuffer, sizeof(obuffer));
         if (len > 0) {
-          if (_caster.at(ic)->ic() == 1)  { emit(newOutBytes1(len));}
-          if (_caster.at(ic)->ic() == 2)  { emit(newOutBytes2(len));}
-          if (_caster.at(ic)->ic() == 3)  { emit(newOutBytes3(len));}
-          if (_caster.at(ic)->ic() == 4)  { emit(newOutBytes4(len));}
-          if (_caster.at(ic)->ic() == 5)  { emit(newOutBytes5(len));}
-          if (_caster.at(ic)->ic() == 6)  { emit(newOutBytes6(len));}
-          if (_caster.at(ic)->ic() == 7)  { emit(newOutBytes7(len));}
-          if (_caster.at(ic)->ic() == 8)  { emit(newOutBytes8(len));}
-          if (_caster.at(ic)->ic() == 9)  { emit(newOutBytes9(len));}
-          if (_caster.at(ic)->ic() == 10) { emit(newOutBytes10(len));}
           _caster.at(ic)->write(obuffer, len);
         }
@@ -287,5 +277,5 @@
     ColumnVector vv(3);
 
-    ep->position(GPSweek12, GPSweeks12, xB, vv);
+    ep->position(GPSweek12, GPSweeks12, xB.data(), vv.data());
     
     ColumnVector xyz;
@@ -333,5 +323,5 @@
 
   outLine.sprintf("%d %.1f %s  %3d  %10.3f  %8.3f %8.3f %8.3f\n", 
-                  GPSweek, GPSweeks, ep->prn().toAscii().data(),
+                  GPSweek, GPSweeks, ep->prn().c_str(),
                   ep->IOD(), dClk, rsw(1), rsw(2), rsw(3));
 
@@ -351,5 +341,5 @@
                                const QString& trafo) {
 
-  bnsSettings settings;
+  bncSettings settings;
 
   if (trafo == "ETRF2000") {
Index: trunk/BNC/upload/bncrtnetdecoder.h
===================================================================
--- trunk/BNC/upload/bncrtnetdecoder.h	(revision 3172)
+++ trunk/BNC/upload/bncrtnetdecoder.h	(revision 3174)
@@ -29,4 +29,5 @@
 #include <QtCore>
 #include "bncephuser.h"
+#include "bncuploadcaster.h"
 #include "RTCM/GPSDecoder.h"
 
@@ -48,5 +49,5 @@
 
   QString _buffer;
-
+  QList<bncUploadCaster*> _caster;
   int    _GPSweek;
   double _GPSweeks;
Index: trunk/BNC/upload/bncuploadcaster.cpp
===================================================================
--- trunk/BNC/upload/bncuploadcaster.cpp	(revision 3172)
+++ trunk/BNC/upload/bncuploadcaster.cpp	(revision 3174)
@@ -27,5 +27,6 @@
 bncUploadCaster::bncUploadCaster(const QString& mountpoint,
                                  const QString& outHost, int outPort,
-                                 const QString& password,  
+                                 const QString& password, 
+                                 const QString& crdTrafo, bool  CoM, 
                                  const QString& outFileName) {
 
@@ -36,4 +37,6 @@
   _outPort    = outPort;
   _password   = password;
+  _crdTrafo   = crdTrafo;
+  _CoM        = CoM;
 
   _outSocket  = 0;
Index: trunk/BNC/upload/bncuploadcaster.h
===================================================================
--- trunk/BNC/upload/bncuploadcaster.h	(revision 3172)
+++ trunk/BNC/upload/bncuploadcaster.h	(revision 3174)
@@ -9,5 +9,6 @@
   bncUploadCaster(const QString& mountpoint,
                   const QString& outHost, int outPort,
-                  const QString& password,  
+                  const QString& password, 
+                  const QString& crdTrafo, bool  CoM, 
                   const QString& outFileName);
   virtual ~bncUploadCaster();
@@ -16,4 +17,6 @@
   void printAscii(const QString& line);
   bool usedSocket() const {return _outSocket;}
+  QString crdTrafo() const {return _crdTrafo;}
+  bool CoM() const {return _CoM;}
 
  signals:
@@ -26,4 +29,6 @@
   int          _outPort;
   QString      _password;
+  QString      _crdTrafo;
+  bool         _CoM;
   QTcpSocket*  _outSocket;
   int          _sOpenTrial;